# 4.0.1

Release date: `2018-11-21`

Changes in command line arguments:

- Changed `consider-ssl-errors` with default as `True` to `ssl-no-verify` with default as `False`.

## Core

- [NXDRIVE-1213](https://jira.nuxeo.com/browse/NXDRIVE-1213): Prevent ignored files from coming back in error after some time
- [NXDRIVE-1236](https://jira.nuxeo.com/browse/NXDRIVE-1236): Fix datetime.fromtimestamp() erronously throws an OSError on Windows
- [NXDRIVE-1259](https://jira.nuxeo.com/browse/NXDRIVE-1259): Be more consistent with file/folder renaming
- [NXDRIVE-1349](https://jira.nuxeo.com/browse/NXDRIVE-1349): Enable DirectEdit on other blobs than the main one
- [NXDRIVE-1401](https://jira.nuxeo.com/browse/NXDRIVE-1401): Clean up usage of deprecated server-side Automation operations
- [NXDRIVE-1417](https://jira.nuxeo.com/browse/NXDRIVE-1417): Handle null properties in objects instantation
- [NXDRIVE-1428](https://jira.nuxeo.com/browse/NXDRIVE-1428): Remove unused functions and methods
- [NXDRIVE-1430](https://jira.nuxeo.com/browse/NXDRIVE-1430): Use SHA256 for Note checksum
- [NXDRIVE-1431](https://jira.nuxeo.com/browse/NXDRIVE-1431): Replace Try, Except, Pass with contextlib.suppress()
- [NXDRIVE-1434](https://jira.nuxeo.com/browse/NXDRIVE-1434): Fix the "consider-ssl-errors" option implementation
- [NXDRIVE-1442](https://jira.nuxeo.com/browse/NXDRIVE-1442): Rename the consider-ssl-errors option to ssl-no-verify

## GUI

- [NXDRIVE-1407](https://jira.nuxeo.com/browse/NXDRIVE-1407): Display CLI arguments in the fatal error screen
- [NXDRIVE-1410](https://jira.nuxeo.com/browse/NXDRIVE-1410): Add a frame to systray layer
- [NXDRIVE-1411](https://jira.nuxeo.com/browse/NXDRIVE-1411): Use consistent icons to edit document / open local folder
- [NXDRIVE-1412](https://jira.nuxeo.com/browse/NXDRIVE-1412): Replace "Synchronization completed" label by "Synchronization complete"
- [NXDRIVE-1413](https://jira.nuxeo.com/browse/NXDRIVE-1413): Prevent long server URL from moving folder and settings icons to the right
- [NXDRIVE-1418](https://jira.nuxeo.com/browse/NXDRIVE-1418): Fix the error and conflict notifications' action
- [NXDRIVE-1421](https://jira.nuxeo.com/browse/NXDRIVE-1421): Enable text selection on server URL and destination folder

## Packaging / Build

- [NXDRIVE-1250](https://jira.nuxeo.com/browse/NXDRIVE-1250): Create the Windows sub-installer for additionnal features
- [NXDRIVE-1389](https://jira.nuxeo.com/browse/NXDRIVE-1389): Upgrade Python from 3.6.6 to 3.6.7
- [NXDRIVE-1404](https://jira.nuxeo.com/browse/NXDRIVE-1404): Create a Windows installer for system wide installation
- [NXDRIVE-1405](https://jira.nuxeo.com/browse/NXDRIVE-1405): Handle local INI system-wide configuration
- [NXDRIVE-1419](https://jira.nuxeo.com/browse/NXDRIVE-1419): Remove hotfixes requirements from versions.yml

## Docs

- [NXDRIVE-1422](https://jira.nuxeo.com/browse/NXDRIVE-1422): Move technical changes into individual change notes
- [NXDRIVE-1424](https://jira.nuxeo.com/browse/NXDRIVE-1424): Fix Windows uninstallation documentation
- [NXDRIVE-1427](https://jira.nuxeo.com/browse/NXDRIVE-1427): Update the GNU/Linux installation steps in the README

## Minor Changes

- Packaging: Added `dataclasses` 0.6
- Packaging: Added `mypy` 0.641
- Packaging: Updated `flake8` from 3.5.0 to 3.6.0
- Packaging: Updated `pre-commit` from 1.11.2 to 1.12.0
- Packaging: Updated `nuxeo` from 2.0.3 to 2.0.4
- Packaging: Updated `psutil` from 5.4.7 to 5.4.8
- Packaging: Updated `python-dateutil` from 2.7.3 to 2.7.5

## Technical Changes

- Removed `AbstractOSIntegration.unregister_protocol_handlers()`
- Removed `Application.create_debug_menu()`
- Removed `Application.dialogs`
- Removed `Application.show_debug_window()`
- Removed `BlacklistItem.increase()`
- Removed `BlacklistQueue.repush()`
- Added `get_value()` to `CLIHandler`
- Added `conf_name` keyword argument to `CLIHandler.load_config()`
- Added `ConfigurationDAO.get_locks()`
- Removed `DarwinIntegration.unregister_protocol_handlers()`
- Removed `DocRemote.get_repository_names()`
- Renamed `Engine.unsynchronize_pair()` to `ignore_pair()`
- Removed `Engine.get_local_watcher()`
- Removed `Engine.get_remote_watcher()`
- Removed `Engine.get_status()`
- Removed `Engine.update_password()`
- Added `ignore` keyword argument to `EngineDAO.unsynchronize_state()`
- Removed `EngineDAO.get_batch_sync_ignore()`
- Removed `EngineDAO.get_next_folder_file()`
- Removed `EngineDAO.get_next_sync_file()`
- Removed `EngineDAO.get_previous_folder_file()`
- Removed `EngineDAO.get_previous_sync_file()`
- Removed `EngineModel.engines`
- Removed `raise_if_missing` keyword argument from `LocalClient.get_info()`
- Added `LocalClient.try_get_info()`
- Removed `LocalClient.make_file()`
- Removed `Manager.dispose_all()`
- Removed `Manager.unbind_all()`
- Changed `ManagerDAO.get_locked_paths()` return type to `List[str]`
- Added `file` and `section` keyword arguments to `MetaOptions.set()`
- Added `file` and `section` keyword arguments to `MetaOptions.update()`
- Changed `Options.consider_ssl_errors=True` to `Options.ssl_no_verify=False`
- Renamed `QMLDriveApi.unsynchronize_pair()` to `ignore_pair()`
- Removed `QMLDriveApi.last_url`
- Removed `QMLDriveApi.show_activities()`
- Removed `QMLDriveApi.show_file_status()`
- Removed `QueueManager.get_local_file_queue()`
- Removed `QueueManager.get_local_folder_queue()`
- Removed `QueueManager.get_remote_file_queue()`
- Removed `QueueManager.get_remote_folder_queue()`
- Removed `QueueManager.requeue_errors()`
- Removed `Remote.conflicted_name()`
- Removed `Remote.fs_exists()`
- Removed `Remote.upload_tmp_dir`
- Removed `raise_if_missing` keyword argument from `Remote.get_fs_info()`
- Removed `mime_type`, `fs` and `apply_versioning_policy` keyword arguments from `Remote.stream_update()`
- Changed `command` keyword argument of `Remote.upload()` to a positional argument
- Removed `SimpleWatcher.get_scan_delay()`
- Removed `SimpleWatcher.is_pending_scan()`
- Removed debug/*
- Moved engine/dao/sqlite.py::`StateRow` to objects.py::`DocPair`
- Added exceptions.py::`UnknownPairState`
- Removed gui/status_dialog.py
- Removed gui/view.py::`NuxeoView`
- Removed notifications.py::`DebugNotification`
- Added objects.py::`Blob`
- Added `blobs` to objects.py::`NuxeoDocumentInfo`
- Removed `digest`, `digest_algorithm`, `has_blob`, and `filename` from objects.py::`NuxeoDocumentInfo` attributes
- Moved options.py::`ServerOptionsUpdater` to options_updater.py
- Removed options.py::`server_updater()`
- Added utils.py::`safe_os_filename()`
- Removed utils.py::`guess_mime_type()`
- Removed utils.py::`make_tmp_file()`
